<html>
<head>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <link rel="stylesheet" href="https://lankadedata.se/spec/assets/style.css">
    <title>Specifikation för skoldata</title>
</head>
<body class="h-entry">
<div class="head">
    <p><a class="logo" href="https://entryscape.com/">
        <img alt="Logga för MetaSolutions AB" src="https://lankadedata.se/spec/assets/metasolutions.png"></a>
    </p>
    <h1 id="title">Specifikation för skoldata</h1>
    <h2 id="subtitle">Information om skolor, förskolor och gymnasier
        <time class="dt-updated" datetime="2018-12-11">2018-12-11</time></h2>
    <div>
        <dl>
            <dt>Denna version:</dt>
            <dd><a class="u-url" href="https://lankadedata.se/spec/skoldata/1.1">https://lankadedata.se/spec/skoldata/1.1</a></dd>
            <dt>Senaste versionen:</dt>
            <dd><a href="https://lankadedata.se/spec/skoldata/">https://lankadedata.se/spec/skoldata/</a></dd>
            <dt>Förra version:</dt>
            <dd><a class="u-url" href="https://lankadedata.se/spec/skoldata/1.0">https://lankadedata.se/spec/skoldata/1.0</a></dd>
            <dt class="editor">Författare:</dt>
            <dd class="editor p-author h-card vcard"><a class="p-name fn u-url url"
                                                         href="mailto:matthias@metasolutions.se">Matthias Palmér</a> - MetaSolutions</dd>
            <dd class="editor p-author h-card vcard">Magnus Burell - Hemnet</dd>
            <dt>Licens:</dt>
            <dd><a href="http://creativecommons.org/licenses/by/4.0/">CC-BY 4.0</a></dd>
        </dl>
    </div>
    <div></div>
    <p class="copyright">Copyright © 2018 <a
            href="https://entryscape.com">MetaSolutions AB</a></p>
    <hr title="Separator for header">
</div>
<nav id="toc">
    <h2>Innehåll</h2>
    <ol class="toc" role="directory">
        <li><a href="#intro"><span class="secno">1</span>Introduktion</a></li>
        <li><a href="#datamodell"><span class="secno">2</span>Datamodell</a></li>
        <li><a href="#csv"><span class="secno">3</span>CSV formatet</a>
            <ol>
                <li><a href="#accessCSV"><span class="secno">3.1</span>Åtkomst via HTTP</a></li>
                <li><a href="#schemaCSV"><span class="secno">3.2</span>Schema</a></li>
            </ol>
        </li>
        <li><a href="#csv"><span class="secno">4</span>JSON formatet</a>
            <ol>
                <li><a href="#accessJSON"><span class="secno">4.1</span>Åtkomst via HTTP</a></li>
                <li><a href="#schemaJSON"><span class="secno">4.2</span>Schema</a></li>
            </ol>
        </li>
        <li><a href="#dcat"><span class="secno">4</span>Beskrivning i datakatalog</a></li>
    </ol>
    <h2>Appendix</h2>
    <ol class="toc">
        <li><a href="#exampleCSV"><span class="secno">A</span>Exempel på skoldata i CSV</a></li>
        <li><a href="#exampleJSON"><span class="secno">B</span>Exempel på skoldata i JSON</a></li>
        <li><a href="#versions"><span class="secno">C</span>Versionshistorik</a></li>
    </ol>
</nav>

<h2 id="intro">1. Introduktion</h2>
<p>Med skoldata menas kontakt- och platsinformation om förskolor, familjedaghem, grundskolor och gymnasier inom en kommun. I texten nedan används för enkelhets skull ordet “skola” för att benämna alla dessa former.</p>
<p>Denna specifikation definierar en enkel tabulär datamodell för skoldata som passar utmärkt att leverera i formatet
    CSV, dvs kommaseparerade värden enligt <a href="https://tools.ietf.org/html/rfc4180">RFC4180</a>. Inget hindrar
    att ytterligare format stöds, t.ex. beskrivs också nedan hur JSON uttrycket ska se ut. Men som grund förutsätts CSV
    kunna levereras då det är praktiskt och skapar förutsägbarhet för mottagare av informationen.</p>

<h2 id="datamodell">2. Datamodell</h2>
<p>Datamodellen är tabulär, där varje rad motsvarar exakt en skola och varje kolumn motsvarar en egenskap för denna skola. 16 kolumner är definierade, där de första 8 är obligatoriska, kolumn 9 och 10 är starkt rekommenderade för att skolinformationen ska få spridning. Övriga kolumner 11 till 16 är frivilliga.</p>
<p class="note"><span class="marker">Observation 1</span>Första kolumnen (source) varierar inte som de andra egenskaperna då den motsvarar vart skolorna tillhör och kommer således vara samma för alla rader som kommer från en kommun. Det kan tyckas onödigt att upprepa detta för varje rad. Alternativet (som valts bort) är att varje mängd skoldata måste kompletteras med information om tillhörighet i en separat metadata fil.</p>
<p class="note"><span class="marker">Observation 2</span>Kolumn 8 och 9 är en förutsättning för att enkelt kunna visa upp skolor på en karta.</p>

<div class="no-overlarge">
<table class="data">
    <caption>Kolumner i datmodellen</caption>
    <colgroup class="header"></colgroup>
    <colgroup span="3"></colgroup>
    <thead>
    <tr>
        <th>#</th>
        <th>Kolumnnamn</th>
        <th>Värdemängd</th>
        <th>Exempel och förklaring</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <th>1</th>
        <td>source</td>
        <td>heltal</td>
        <td>Ange <a href="https://www.scb.se/hitta-statistik/regional-statistik-och-kartor/regionala-indelningar/lan-och-kommuner/lan-och-kommuner-i-kodnummerordning/">SCB:s kommunkod</a> för er kommun. Exempel: "0163" för Sollentuna kommun.</td>
    </tr>
    <tr>
        <th>2</th>
        <td>id</td>
        <td>text</td>
        <td>Ange en unik och stabil  identifierare för skolan inom er kommun, förslagsvis ett heltal, men en text är också acceptabelt. Undvik mellanslag och andra tecken som inte passar bra i en URI (webbadress). Man använda namnet för skolan, men då ersätta mellanrum med “_”, t.ex. “Förskolan_Bikupan”.</td>
    </tr>
    <tr>
        <th>3</th>
        <td>name</td>
        <td>text</td>
        <td>Ange skolans namn. Exempel: "Förskolan Bikupan"</td>
    </tr>
    <tr>
        <th>4</th>
        <td>type</td>
        <td>FS|FD|<br/>GR|GY|KV</td>
        <td>Ange typ av skola, alternativen motsvarar:
            FörSkola, FamiljeDaghem, GRundskola, GYmnasium, KomVux
            Använd de angivna förkortningarna i versaler.
        </td>
    </tr>
    <tr>
        <th>5</th>
        <td>operation</td>
        <td>K|F</td>
        <td>Ange ett av alternativen: "Kommunal", "Fristående/Privat".
            Använd de angivna förkortningarna i versaler.
        </td>
    </tr>
    <tr>
        <th>6</th>
        <td>street</td>
        <td>text</td>
        <td>Ange gatuadress (för besöksadressen) inklusive gatunummer. Exempel: "Drevkarlsstigen 5"</td>
    </tr>
    <tr>
        <th>7</th>
        <td>postalcode</td>
        <td>heltal</td>
        <td>Ange postnummer <strong>utan</strong> mellanslag. Exempel: “19253"</td>
    </tr>
    <tr>
        <th>8</th>
        <td>locality</td>
        <td>text</td>
        <td>Ange postort. Exempel: "Sollentuna"</td>
    </tr>
    <tr>
        <th>9</th>
        <td>lat</td>
        <td>WGS84</td>
        <td>Ange latitud enligt WGS84. WGS84 är samma koordinatsystem som används av GPS samt av de flesta
            karttjänster som t.ex. Google Maps, Bing Maps, OpenStreetMap, Mapquest, Esri, Mapbox osv. Exempel:
            59.4434403</td>
    </tr>
    <tr>
        <th>10</th>
        <td>long</td>
        <td>WGS84</td>
        <td>Ange longitud enligt WGS84. Exempel: 17.96793</td>
    </tr>
    <tr>
        <th>11</th>
        <td>email</td>
        <td>email</td>
        <td>Ange e-postadress för allmänna frågor till skolan. Uttryckt i enlighet med <a
                href="https://tools.ietf.org/html/rfc6068">RFC6068</a> utan “mailto:” scheme delen, t.ex.
            “johan@example.com”</td>
    </tr>
    <tr>
        <th>12</th>
        <td>phone</td>
        <td>heltal och -</td>
        <td>Ange telefonnummer (inklusive riktnummer) till skolans växel eller motsvarande. Använd - inte mellanrum om du vill öka läsbarheten (detta för att öka kompatibiliteten med <a
                href="https://tools.ietf.org/html/rfc3966">RFC3966</a>). T.ex.: 018-727-00-00
            Ange inte landskod, +, parentes eller liknande.
        </td>
    </tr>
    <tr>
        <th>13</th>
        <td>url</td>
        <td>URL</td>
        <td>Ange i första hand fullständig webbadress till skolan, i andra hand webbadressen till en samlingssida för
            skolor på kommunens webbplats. Exempel:
            <a
                    href="https://www.sollentuna.se/sv/uweb/gardesskolan-med-forskolor/vara-verksamheter1/Forskolan/">https://www.sollentuna.se/sv/uweb/gardesskolan-med-forskolor/vara-verksamheter1/Forskolan/</a>
            Notera att man måste ange URL:en med protokoll, dvs inklusive http:// eller https://.
        </td>
    </tr>
    <tr>
        <th>14</th>
        <td>capacity</td>
        <td>heltal</td>
        <td>Antal platser / elever som skolan kan ta emot.</td>
    </tr>
    <tr>
        <th>15</th>
        <td>open.from</td>
        <td>hh:mm</td>
        <td>Ange timme och minut i ett format som är kompatibelt med ISO 8601, t.ex. 07:30.</td>
    </tr>
    <tr>
        <th>16</th>
        <td>open.to</td>
        <td>hh:mm</td>
        <td>Ange timme och minut i ett format som är kompatibelt med ISO 8601, t.ex. 17:00.</td>
    </tr>
    </tbody>
</table>
</div>

<h2 id="csv">3. CSV formatet</h2>
<p>Det enklaste formatet att stödja för skoldata är CSV formatet enligt <a href="https://tools.ietf.org/html/rfc4180">RFC4180</a>. Se exemplet i <a href="#exampleCSV">Appendix
    A</a>. Det som krävs är att första raden indikerar vilka kolumner som stödjs (mellan 8 och 16 stycken):</p>
    <strong class="advisement">source,id,name,type,operation,street,postalcode,locality,lat,long,email,phone,url,capacity,
        open.from,open.to</strong>
<p>Utöver det som sägs i RFC4180 krävs alltid att informationen är
    uttryckt med teckenkodning UTF-8. På grund av att CSV har funnits länge och det finns en uppsjö
        av olika ramverk och program som inte alla följer RFC4180 så uppmanas man följa devisen:
    </p>
    <p class="note"><em>"Be conservative in what you do, be liberal in what you accept from others"</em></p>
    <p>För den här specifikationen innebär det att implementatörer rekommenderas även stödja semikolonseparerade filer.
        Orsaken är att Microsoft Excel använder semikolon istället för komma i CSV filer på operativsystem med svenska
        som default. Detta på grund av att komma används för decimaltal vilket ofta förekommer i CSV-filer vilket skulle kräva en omfattande användning av dubbla citationstecken kring värden.</p>
    <p>För att särskilja skoldata som är semikolonseparerade från kommaseparerade måste första raden se ut som:</p>
    <strong class="advisement">source;id;name;type;operation;street;postalcode;locality;lat;long;email;phone;url;capacity;open.from;open.to</strong>

<h3 id="accessCSV">3.1 Åtkomst via HTTP</h3>
    <p>Om skoldata görs tillgängligt på en webbadress bör följande gälla:</p>
    <ul>
        <li>Content-type ska vara text/csv (även för skoldata med semikolonseparerade värden)</li>
        <li>Last-modified bör ange när skoldatat senast ändrats</li>
        <li>HEAD requests bör stödjas där Last-modified ingår</li>
    </ul>

<h3 id="schemaCSV">3.2 Schema</h3>
<p>Du som är nöjd med att leverera eller använda skoldata utifrån vad som beskrivs skrifligen i denna specifikation och
    exemplifieras i appendixen kan ignorera detta avsnitt.</p>
<p>Sedan 2015 finns, <a href="https://www.w3.org/TR/tabular-metadata/">"Metadata Vocabulary for
    Tabular Data"</a>, en W3C rekommendation för hur man anger metadata för datamodeller uttryckta i CSV.</p>
<strong class="advisement">Schema för skoldata: <a href="https://lankadedata.se/spec/skoldata/schema.json">https://lankadedata.se/spec/skoldata/schema.json</a></strong>
<p>För skoldata innebär detta schema:</p>
<ul>
    <li>maskinell verifering att CSV-uttryck är korrekta</li>
    <li>länka ihop skoldatan med andra datakällor</li>
    <li>konvertera skoldata till länkade data</li>
</ul>
<p>De två sistnämnda kommer sig av att schemat också tillhandahåller saknad information, bland annat hur man
    konverterar ett visst CSV uttryck till RDF. Mer specifikt innehåller metadatan hur rader konverteras
    till instanser av <a href="https://schema.org/">schema.orgs</a> <a href="https://schema.org/EducationalOrganization">EducationalOrganization</a>.</p>
<p>Valet av schema.org gjordes eftersom den tillhandahåller en mängd egenskaper som till stor del täcker in
    skolinformationen. För den som är intresserad går det att hitta andra representationer av skolor som
    RDF/länkade data.</p>

<h2 id="json">4. JSON formatet</h2>
<p>JSON uttrycket följer direkt ifrån CSV schemat och
    <a href="https://www.w3.org/TR/csv2json/">W3C rekommendationen "Generating JSON from Tabular Data on the Web"</a>
    . Se exempel i <a href="#exampleJSON">appendix B</a>.</p>

<h3 id="accessJSON">4.1 Åtkomst via HTTP</h3>
<p>Samma gäller som <a href="#accessCSV">för CSV</a> förutom att content-type ska vara "application/json".</p>

<h3 id="schemaJSON">4.2 Schema</h3>
<p>Indirekt via <a href="#schemaCSV">CSV schemat</a>.</p>

<h2 id="dcat">5. Beskrivning i datakatalog</h2>
<p>För den som vill lägga in sin skoldata som en datamängd i en datakatalog ska man använda sig av <a href="https://www.w3.org/TR/vocab-dcat/">W3C
    rekommendationen DCAT</a>. För
    svenska behov är det <a href="https://lankadedata.se/spec/DCAT-AP-SE/">DCAT-AP-SE</a> som gäller. För att göra
    det enklare att hitta alla datamängder som följer skoldataspecifikationen på t.ex. <a
            href="https://oppnadata.se">öppnadata.se</a> är det viktigt att man markerar dessa datamängder. Man bör
    då göra följande:</p>
<ol>
    <li>På datamängden peka ut denna specifikation via propertyn dcterms:conformsTo (med fältnamnet "uppfyller").</li>
    <li>Lägg till "skoldata" som nyckelord på svenska.</li>
    <li>På distributionen som motsvarar CSV filen peka ut schemat via propertyn dcterms:conformsTo (med fältnamnet "länkade
        scheman").</li>
</ol>
<pre class="example">
<span class="marker">Exempel: Datamängd med skoldata uttryckt i en DCAT katalog</span>
&lt;dcat:Catalog>
    &lt;dct:title>En datakatalog&lt;/dct:title>
    &lt;dcat:dataset rdf:resource="http://example.com/dataset1"/>
&lt;/dcat:Catalog>
&lt;dcat:Dataset rdf:about="http://example.com/dataset1">
    &lt;dct:title>En skoldatamängd&lt;/dct:title>
    &lt;dcat:keyword xml:lang="sv">skoldata&lt;/dcat:keyword>
    &lt;dct:conformsTo rdf:resource="https://lankadedata.se/spec/skoldata/"/>
    &lt;dcat:distribution rdf:resource="http://example.com/distribution1"/>
&lt;/dcat:Dataset>
&lt;dcat:Distribution rdf:about="http://example.com/distribution1">
    &lt;dct:title>Skoldata som CSV&lt;/dct:title>
    &lt;dcat:downloadURL rdf:resource="http://example.com/skoldatafil.csv"/>
    &lt;dcat:accessURL rdf:resource="http://example.com/skoldatafil.csv"/>
    &lt;dct:format>text/csv&lt;/dct:format>
    &lt;dct:conformsTo rdf:resource="https://lankadedata.se/spec/skoldata/schema.json"/>
&lt;/dcat:Distribution>
</pre>
<h2 id="exampleCSV">Appendix A: Exempel på skoldata i CSV</h2>
I exemplet nedan ser ni första raden med kolumnnamn och sen en förskola, en grundskola och en
gymnasieskola. Alla tre skolorna har de 13 första kolumnerna ifyllda.
<pre class="example">
<span class="marker">Exempel: Tre skolor från Södertälje</span>
source,id,name,type,operation,street,postal code,locality,lat,long,url
0181,1023_algarden,Algården förskola,FS,K,Algårdsv 1,15249,Södertälje,59.2111914307184,17.633231273029,https://www.sodertalje.se/skola-och-forskola/Forskola/Forskolor/Algardens-forskola/
0181,3003_soldalaskolan,Soldalaskolan,GR,K,Lundbygatan 5,15146,Södertälje,59.1856082200489,17.6046049054264,https://www.sodertalje.se/Soldalaskolan
0181,6005_orjangymnasiet,Örjangymnasiet,GY,F,Nibble,15191,Järna,59.0660021271055,17.616635823744,http://www.orjangymnasiet.se
</pre>

<h2 id="exampleJSON">Appendix B: Exempel på skoldata i JSON</h2>
Nedan ser ni första raden från exemplet ovan som JSON.
<pre class="example">
<span class="marker">Exempel: En förskola i Södertälje</span>
{
  "street": "Algårdsv 1",
  "postal code": "15249",
  "name": "Algården förskola",
  "locality": "Södertälje",
  "id": "1023_algarden",
  "source": "0181",
  "type": "FS",
  "operation": "K",
  "lat": "59.2111914307184",
  "url": "https://www.sodertalje.se/skola-och-forskola/Forskola/Forskolor/Algardens-forskola/",
  "long": "17.633231273029"
}
</pre>
<h2 id="versions">Appendix C: Versionshistorik</h2>

<ul class="versions">
    <li>2018-12-11 - Version 1.1
        <ul>
            <li>Flyttade över specifikationen till en ny mall.</li>
            <li>Flyttade upp och renodlade kapitel 2 om datamodell.</li>
            <li>Sammanfattande kapitel om CSV formatet.</li>
            <li>Schema / tabell metadata för CSV i separat fil.</li>
            <li>Introducerade kapitel om JSON format.</li>
            <li>Introducerade kapitel om uttryck i DCAT.</li>
            <li>Introducerade appendix A och B med exempel.</li>
        </ul>
    </li>
    <li>2018-11-22 - Småfixar
        <ul>
            <li>La till permanent adress till specifikationen.</li>
            <li>Översatte rubriken på versionshistorik till svenska.</li>
            <li>Ändrade kapitalisering i kolumn 4 från GrundSkola till GRundskola så det blir tydligt vad koden ‘GR’ står för.</li>
        </ul>
    </li>
    <li>2017-03-19 - Slutrevision 1.0
        <ul>
            <li>Slut granskning gjord.</li>
            <li>Publicering av Lunds kommun gjord enligt specifikation.</li>
        </ul>
    </li>
    <li>2016-11-17 - Renodlad specifikation
        <ul>
            <li>Separation av modell och format.</li>
            <li>Förtydling av förväntade värden per kolumn.</li>
            <li>Fler kolumner baserat på exempel från Haninge.</li>
            <li>Tabell annotering enligt CSV on the web för validering och konvertering till RDF.</li>
        </ul>
    </li>
    <li>2016-10-21 - Utkast av Magnus Burell på Hemnet
        <ul>
            <li>Förslag på CSV uttryck.</li>
            <li>Förslag på kolumner från tidigare inhämtad data.</li>
        </ul>
    </li>
</ul>
</body>
<script src="fixup.js"></script>
</html>